#ifndef _H_3A4A7223F8D3A36B294D642C12A78DB3_ConnectedClient_DCPS_H_
#define _H_3A4A7223F8D3A36B294D642C12A78DB3_ConnectedClient_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ConnectedClient_.h"


namespace rosbridge_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ConnectedClient_TypeSupportInterface;

            typedef ConnectedClient_TypeSupportInterface * ConnectedClient_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ConnectedClient_TypeSupportInterface> ConnectedClient_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ConnectedClient_TypeSupportInterface> ConnectedClient_TypeSupportInterface_out;


            class ConnectedClient_DataWriter;

            typedef ConnectedClient_DataWriter * ConnectedClient_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ConnectedClient_DataWriter> ConnectedClient_DataWriter_var;
            typedef DDS_DCPSInterface_out < ConnectedClient_DataWriter> ConnectedClient_DataWriter_out;


            class ConnectedClient_DataReader;

            typedef ConnectedClient_DataReader * ConnectedClient_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ConnectedClient_DataReader> ConnectedClient_DataReader_var;
            typedef DDS_DCPSInterface_out < ConnectedClient_DataReader> ConnectedClient_DataReader_out;


            class ConnectedClient_DataReaderView;

            typedef ConnectedClient_DataReaderView * ConnectedClient_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ConnectedClient_DataReaderView> ConnectedClient_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ConnectedClient_DataReaderView> ConnectedClient_DataReaderView_out;

            struct ConnectedClient_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ConnectedClient_, struct ConnectedClient_Seq_uniq_> ConnectedClient_Seq;
            typedef DDS_DCPSSequence_var < ConnectedClient_Seq> ConnectedClient_Seq_var;
            typedef DDS_DCPSSequence_out < ConnectedClient_Seq> ConnectedClient_Seq_out;

            class  ConnectedClient_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ConnectedClient_TypeSupportInterface_ptr _ptr_type;
                typedef ConnectedClient_TypeSupportInterface_var _var_type;

                static ConnectedClient_TypeSupportInterface_ptr _duplicate (ConnectedClient_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ConnectedClient_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ConnectedClient_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ConnectedClient_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ConnectedClient_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ConnectedClient_TypeSupportInterface () {};
                ~ConnectedClient_TypeSupportInterface () {};
            private:
                ConnectedClient_TypeSupportInterface (const ConnectedClient_TypeSupportInterface &);
                ConnectedClient_TypeSupportInterface & operator = (const ConnectedClient_TypeSupportInterface &);
            };

            class  ConnectedClient_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ConnectedClient_DataWriter_ptr _ptr_type;
                typedef ConnectedClient_DataWriter_var _var_type;

                static ConnectedClient_DataWriter_ptr _duplicate (ConnectedClient_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ConnectedClient_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ConnectedClient_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ConnectedClient_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ConnectedClient_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ConnectedClient_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ConnectedClient_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ConnectedClient_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ConnectedClient_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ConnectedClient_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ConnectedClient_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ConnectedClient_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ConnectedClient_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ConnectedClient_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ConnectedClient_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ConnectedClient_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ConnectedClient_& instance_data) = 0;

            protected:
                ConnectedClient_DataWriter () {};
                ~ConnectedClient_DataWriter () {};
            private:
                ConnectedClient_DataWriter (const ConnectedClient_DataWriter &);
                ConnectedClient_DataWriter & operator = (const ConnectedClient_DataWriter &);
            };

            class  ConnectedClient_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ConnectedClient_DataReader_ptr _ptr_type;
                typedef ConnectedClient_DataReader_var _var_type;

                static ConnectedClient_DataReader_ptr _duplicate (ConnectedClient_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ConnectedClient_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ConnectedClient_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ConnectedClient_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ConnectedClient_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ConnectedClient_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ConnectedClient_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ConnectedClient_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ConnectedClient_& instance) = 0;

            protected:
                ConnectedClient_DataReader () {};
                ~ConnectedClient_DataReader () {};
            private:
                ConnectedClient_DataReader (const ConnectedClient_DataReader &);
                ConnectedClient_DataReader & operator = (const ConnectedClient_DataReader &);
            };

            class  ConnectedClient_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ConnectedClient_DataReaderView_ptr _ptr_type;
                typedef ConnectedClient_DataReaderView_var _var_type;

                static ConnectedClient_DataReaderView_ptr _duplicate (ConnectedClient_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ConnectedClient_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ConnectedClient_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ConnectedClient_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ConnectedClient_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ConnectedClient_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ConnectedClient_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ConnectedClient_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ConnectedClient_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ConnectedClient_& instance) = 0;

            protected:
                ConnectedClient_DataReaderView () {};
                ~ConnectedClient_DataReaderView () {};
            private:
                ConnectedClient_DataReaderView (const ConnectedClient_DataReaderView &);
                ConnectedClient_DataReaderView & operator = (const ConnectedClient_DataReaderView &);
            };
        }

    }

}

#endif
